//쌠
//ZLIB 1.13   Copyright(c) Jean-loup Gailly and Mark Adler
//ZLib.pas    Copyright(c) 1997 Borland International

//OBJt@C̃\[X(zlib 1.1.3)͈ȉœł܂B
//http://www.info-zip.org/pub/infozip/zlib

//ӎ
//OBJt@C̍쐬@ĂꂽumasvB肪Ƃ܂B


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure BMP2PNG(FileName: string);
    procedure Zlib_Encode(var OutFile : TStream);
  public
    { Public 錾 }
  end;

//CRC`FbJ[
{$L crc32.obj}
function crc32(crc: integer; buf: pointer; len: integer): integer; external;

var
  Form1: TForm1;

implementation
uses
 zlib,PNG_h;

{$R *.DFM}


//////// Big Endian<->Litle Endian
function IntelOder_Dword(Buffer :Dword):Dword;
begin
 Result   :=(Buffer AND $000000FF) shl 24 ;
 Result   :=Result or ((Buffer AND $0000FF00) shl 8) ;
 Result   :=Result or ((Buffer AND $00FF0000) shr 8) ;
 Result   :=Result or ((Buffer AND $FF000000) shr 24)  ;
end;

/////////  ZLIB Encoder
procedure TForm1.Zlib_Encode(var OutFile : TStream);
var
  Encode          : TCompressionStream;
  Row,Col         : Integer;
  Buffer_Width    : Integer;
  Buffer          : pByteArray;
  SrcRow          : pRGBarray;
  Zero            : BYTE;
begin
  Zero:=0;

  //TCYvZ
  Buffer_Width := (Image1.picture.bitmap.Width * 3 * 8) div 8 ;

  //ሳk
  //Encode := TCompressionStream.Create(clFastest,OutFile);
  //Wk
  Encode := TCompressionStream.Create(clDefault,OutFile);
  //ᑬk
  //Encode := TCompressionStream.Create(clMax,OutFile);

  GetMem(Buffer, Buffer_Width);

try
  //Bits Data Write
  for Row := 0 to Image1.picture.bitmap.Height - 1 do
  begin
     SrcRow := Image1.picture.bitmap.ScanLine[Row];
     for Col := 0 to Image1.picture.bitmap.Width - 1 do
     begin
        Buffer^[Col * 3]       :=SrcRow[Col].rgbtRed;
        Buffer^[1 + (Col * 3)] :=SrcRow[Col].rgbtGreen;
        Buffer^[2 + (Col * 3)] :=SrcRow[Col].rgbtBlue;
     end;
     Encode.Write(Zero, 1);
     Encode.Write(Buffer^, Buffer_Width);
  end;

finally
  Encode.free;
  FreeMem(Buffer, Buffer_Width);
end;

end;

/////////
procedure TForm1.BMP2PNG(FileName: string);
Var
 PNGIHDR: TPNGIHDR;
 Len    : DWORD;
 EncodeStream : TMemoryStream;
 WriteStream  : TMemoryStream;
 crc: integer;
begin

 if Image1.Picture.Bitmap.Empty then exit;
 // The PNG Bits is 24bit Only.
 if Image1.Picture.Bitmap.PIxelFormat<>pf24bit then  Image1.Picture.Bitmap.PIxelFormat :=pf24bit;

 ZeroMemory(@PNGIHDR,sizeof(TPNGIHDR));

 EncodeStream:=TMemoryStream.Create;
 WriteStream :=TMemoryStream.Create;

try

 //PNGwb_[\z
 WriteStream.Write(PNG_HEADER,8);
 PNGIHDR.Width    := IntelOder_Dword(Image1.Picture.Bitmap.Width);
 PNGIHDR.Height   := IntelOder_Dword(Image1.Picture.Bitmap.Height);
 PNGIHDR.BitDepth := 8;
 PNGIHDR.ColorType:= PNGCOLOR_COLOR;

 //IHDR`N----->

    Len:=IntelOder_Dword(13);

    //`NOX
    WriteStream.Write(Len,4);
    //`N^Cv
    WriteStream.Write(PNG_IHDR,4);
    //`Nf[^
    WriteStream.Write(PNGIHDR,sizeof(TPNGIHDR));
    //CRCf[^
    crc:=crc32(0,nil,0);
    crc:=crc32(crc,@PNG_IHDR,4);
    crc:=crc32(crc,@PNGIHDR,13);
    crc:=IntelOder_Dword(crc);
    WriteStream.Write(crc,4);

 //IDAT`N----->

    //f[^k
    Zlib_Encode(TStream(EncodeStream));

    Len:=IntelOder_Dword(EncodeStream.size);

    //`NOX
    WriteStream.Write(Len,4);
    //`N^Cv
    WriteStream.Write(PNG_IDAT,4);
    //`Nf[^
    WriteStream.write(EncodeStream.Memory^,EncodeStream.size);
    //CRC
    crc:=crc32(0,nil,0);
    crc:=crc32(crc,@PNG_IDAT,4);
    crc:=crc32(crc,EncodeStream.Memory,EncodeStream.size);
    crc:=IntelOder_Dword(crc);
    WriteStream.Write(crc,4);

//IEND`N----->

    Len:=IntelOder_Dword(0);

    //`NOX
    WriteStream.Write(Len,4);
    //`N^Cv
    WriteStream.Write(PNG_IEND,4);
    //CRC
    crc:=crc32(0,nil,0);
    crc:=crc32(crc,@PNG_IEND,4);
    crc:=IntelOder_Dword(crc);
    WriteStream.Write(crc,4);

 WriteStream.Savetofile(FileName);

finally
 WriteStream.free;
 EncodeStream.free;
end;

end;

/////////
procedure TForm1.Button2Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 image1.picture.bitmap.LoadFromFile(OpenDialog1.Filename);
end;

/////////
procedure TForm1.Button1Click(Sender: TObject);
begin
 if Image1.Picture.Bitmap.Empty then Exit;
 if SaveDialog1.Execute then BMP2PNG(SaveDialog1.FileName);
end;

end.
